﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Security.Cryptography;
using System.Security.Cryptography.X509Certificates;
public partial class receivePg : System.Web.UI.Page
{
  
    protected void Page_Load(object sender, EventArgs e)
    {
        //bankDealId,bankId,dealId,dealTime,errCode,ext1,ext2,merchantAcctId,orderAmount,orderCurrency,orderId,orderTime,payResult,payType,terminalId,version
        //人民币网关账号，
        string merchantAcctId = Request.QueryString["merchantAcctId"].ToString();
        //网关版本
        string version = Request.QueryString["version"].ToString();
        //支付方式
        string payType = Request.QueryString["payType"].ToString();
        //银行代码
        string bankId = "";
        if (Request.QueryString["bankId"] != null)
        {
            bankId = Request.QueryString["bankId"].ToString();
        }
        //商户订单号
        string orderId = Request.QueryString["orderId"].ToString();
        //商户终端号
        string terminalId = Request.QueryString["terminalId"].ToString();
        //订单提交时间
        string orderTime = Request.QueryString["orderTime"].ToString();
        //订单金额
        string orderAmount = Request.QueryString["orderAmount"].ToString();
        // 交易号，
        string dealId = Request.QueryString["dealId"].ToString();
        //银行交易号 
        string bankDealId = "";
        if (Request.QueryString["bankDealId"] != null)
        {
            bankDealId = Request.QueryString["bankDealId"].ToString();
        }
        //交易时间，
        string dealTime = Request.QueryString["dealTime"].ToString();
        //交易币别
        string orderCurrency = Request.QueryString["orderCurrency"].ToString();

        //扩展字段1，该值与提交时相同。
    string ext1 = "";
        if (Request.QueryString["ext1"] != null)
        {
            ext1 = Request.QueryString["ext1"].ToString();
        }

        //扩展字段2，该值与提交时相同。
        string ext2 = "";
        if (Request.QueryString["ext2"] != null)
        {
            ext2 = Request.QueryString["ext2"].ToString();
        }

        //处理结果，
        string payResult = Request.QueryString["payResult"].ToString();
        //错误代码 
        string errCode = Request.QueryString["errCode"].ToString();
        //签名字符串 
        string signMsg = Request.QueryString["signMsg"].ToString();
        string signMsgVal = "";
        signMsgVal = appendParam(signMsgVal, "bankDealId", bankDealId);
        signMsgVal = appendParam(signMsgVal, "bankId", bankId);
        signMsgVal = appendParam(signMsgVal, "dealId", dealId);
        signMsgVal = appendParam(signMsgVal, "dealTime", dealTime);
        signMsgVal = appendParam(signMsgVal, "errCode", errCode);
        signMsgVal = appendParam(signMsgVal, "ext1", ext1);
        signMsgVal = appendParam(signMsgVal, "ext2", ext2);
        signMsgVal = appendParam(signMsgVal, "merchantAcctId", merchantAcctId);
        signMsgVal = appendParam(signMsgVal, "orderAmount", orderAmount);
        signMsgVal = appendParam(signMsgVal, "orderCurrency", orderCurrency);
        signMsgVal = appendParam(signMsgVal, "orderId", orderId);
        signMsgVal = appendParam(signMsgVal, "orderTime", orderTime);
        signMsgVal = appendParam(signMsgVal, "payResult", payResult);
        signMsgVal = appendParam(signMsgVal, "payType", payType);
        signMsgVal = appendParam(signMsgVal, "terminalId", terminalId);
        signMsgVal = appendParam(signMsgVal, "version", version);


        ///UTF-8编码  GB2312编码  用户可以根据自己网站的编码格式来选择加密的编码方式
        ///byte[] bytes = Encoding.GetEncoding("GB2312").GetBytes(signMsgVal);
        byte[] bytes = System.Text.Encoding.UTF8.GetBytes(signMsgVal); 
        byte[] SignatureByte = Convert.FromBase64String(signMsg);
        X509Certificate2 cert = new X509Certificate2(Server.MapPath("ChinaPnR.rsa.cer"), "");
        RSACryptoServiceProvider rsapri = (RSACryptoServiceProvider)cert.PublicKey.Key;
        rsapri.ImportCspBlob(rsapri.ExportCspBlob(false));
        RSAPKCS1SignatureDeformatter f = new RSAPKCS1SignatureDeformatter(rsapri);
        byte[] result;
        f.SetHashAlgorithm("SHA1");
        SHA1CryptoServiceProvider sha = new SHA1CryptoServiceProvider();
        result = sha.ComputeHash(bytes);

        String verifySignature = "";
 //       Response.Write("错误码：" + errCode);
       

        if (f.VerifySignature(result, SignatureByte))
        {

           verifySignature = "true";

        }
        else {
           verifySignature = ("false");
        }
        Response.Redirect("show.aspx?errCode=" + errCode + "&orderId=" + orderId  + "&orderAmount=" + orderAmount + "&dealId=" + dealId + "&orderTime=" + orderTime + "&verifySignature=" + verifySignature + "&payResult=" + payResult);

    }
    //功能函数。将变量值不为空的参数组成字符串
    String appendParam(String returnStr, String paramId, String paramValue)
    {

        if (returnStr != "")
        {

            if (paramValue != "")
            {

                returnStr += "&" + paramId + "=" + paramValue;
            }

        }
        else
        {

            if (paramValue != "")
            {
                returnStr = paramId + "=" + paramValue;
            }
        }

        return returnStr;
    }
}
